\section{Overview}

The goal of this document is to present the Integration Problems toolbox 
for Scilab.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Introduction}

The goal of this toolbox is to provide integration problems
in order to test integration algorithms.
Each problem is provided as a function which takes a real argument $\bx\in[0,1]^s$
in the unit hypercube and returns a real output $y=f(\bx)\in\RR$.

This toolbox can be used in the context of the numerical evaluation of 
any numerical integration algorithms.
However, it was designed to serve as a base for testing Monte Carlo (MC) 
and Quasi Monte Carlo (QMC) algorithms.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Overview of functions}

The 23 test functions provided in the toolbox are presented 
in the table \ref{fig-intprb-testfuns}.

\begin{figure}
\begin{center}
\begin{tabular}{|llll|}
\hline
No     & File     & $s$   & Name \\
\hline
SUM       & (10) & Sum      \\  
SQSUM     & (10) & Sum of Squares \\
SUMSQROOT & (10) & Sum of Square Roots \\
PRODONES  & (10) & Product of Signed Ones \\
PRODEXP   & (10) & Product of Exponentials \\
PRODCUB   & (10) & Product of Cubes \\
PRODX     & (10) & Product of X \\
SUMFIFJ   & (10) & Sum of fi fj \\
SUMF1FJ   & (10) & Sum of f1 fj \\
HELLEKALEK & (10) & Hellekalek \\
ROOSARNOLD1    & (10) & Roos and Arnold 1 \\
ROOSARNOLD2    & (10) & Roos and Arnold 2 \\
ROOSARNOLD3    & (10) & Roos and Arnold 3 \\
RST1           & (10) & Radovic, Sobol, Tichy ($a_j=1$) \\
RST2           & (10) & Radovic, Sobol, Tichy ($a_j=j$) \\
RST3           & (10) & Radovic, Sobol, Tichy ($a_j=j^2$) \\
SOBOLPROD      & (10) & Sobol Product \\
OSCILL         & (6) &  Genz - Oscillatory \\
PRPEAK         & (6) &  Genz - Product Peak \\
CORPEAK        & (6) &  Genz - Corner Peak \\
GAUSSIAN       & (6) &  Genz - Gaussian \\
C0             & (6) &  Genz - C0  \\
DISCONT        & (6) &  Genz - Discontinuous \\
\hline
\end{tabular}
\end{center}
\caption{Test functions provided in the toolbox.}
\label{fig-intprb-testfuns}
\end{figure}

The functions SUM, SQSUM, SUMSQROOT, PRODONES, PRODEXP, PRODCUB, 
PRODX, SUMFIFJ, SUMF1FJ are taken from Kocis and Whiten \cite{KocisWhiten1997}.
The functions HELLEKALEK, RST1, RST2, RST3, SOBOLPROD are taken from Owen \cite{OwenDimdist2003}.
The functions ROOSARNOLD1, ROOSARNOLD2, ROOSARNOLD3 are from Roos and Arnold \cite{Roos1963}.
The functions OSCILL, PRPEAK, CORPEAK, GAUSSIAN, C0, DISCONT are taken from 
Genz \cite{Genz1984}.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Designing test functions}

In this section, we describe how and why most functions provided in this 
toolbox are with expectation zero and variance unity.

We assume that $s$ is a positive integer and that the point $\bx\in[0,1]^s$.
The function $f:[0,1]^s \rightarrow \RR$ is assumed to have a finite 
expectation 
\begin{eqnarray}
E(f) = \int_{[0,1]^s} f(\bx)d\bx,
\end{eqnarray}
and finite variance 
\begin{eqnarray}
\sigma^2(f) = \int_{[0,1]^s} f(\bx)^2 d\bx - E(f)^2.
\end{eqnarray}

Assume that we approximate the expectation of the function by the 
Monte-Carlo estimate \cite{MontecarloHammersley1964} 
\begin{eqnarray}
I = \frac{1}{n} \sum_{k=1,\ldots,n} f(\bx_k),
\end{eqnarray}
where the points $\bx_k$ are independent uniformly distributed points in the hypercube $[0,1]^s$.
The estimate $I$ is an unbiased estimator of $E(f)$, and its variance is 
\begin{eqnarray}
\int_{[0,1]^s} (f(\bx) - E(f))^2 d\bx = \frac{\sigma^2(f)}{n}.
\end{eqnarray}

In \cite{KocisWhiten1995}, Kocis and Whiten provide analysis of 
test functions by using the functional ANOVA. The purpose of their 
work is to describe what particular functions are difficult to 
integrate with Monte-Carlo and Quasi-Monte-Carlo methods.
They state that "adding a large constant to the test function (assumed 
small) improves the relative accuracy of the integration, but clearly 
this is of no significance in testing an integration 
sequence." Thus, "the first step should be to remove any constant component
from the test function as follows:"
\begin{eqnarray}
f_0 = E(f) = \int_{[0,1]^s} f(\bx)d\bx,
\end{eqnarray}
and the remaining part of $f(\bx)$ is $f(\bx) - f_0$.

Later in their text, they notice that, in the case of Monte-Carlo 
integration, the error depends on the variance of the function being integrated.
Hence, the suggest that to give comparable results, the variance of the function should be 
normalised to a constant value, chosen, without loss of generality to be one.
Let us consider the function $\overline{f}$ defined by 
\begin{eqnarray}
\label{intprb-normalizedf}
\overline{f}(\bx) = \frac{1}{\sqrt{\sigma^2(f)}} \left( f(\bx) - E(f)\right).
\end{eqnarray}
Then the expectation of the function $\overline{f}$ is 
\begin{eqnarray}
E(\overline{f}(X)) 
& = & \int_{[0,1]^s} \overline{f}(\bx)d\bx \\
& = & \frac{1}{\sqrt{\sigma^2(f)}} \int_{[0,1]^s} \left( f(\bx) - E(f)\right) d\bx \\
& = & \frac{1}{\sqrt{\sigma^2(f)}} \left(  \int_{[0,1]^s} f(\bx) d\bx - E(f) \right) \\
& = & 0,
\end{eqnarray}
and the variance of the function $\overline{f}$ is 
\begin{eqnarray}
\sigma^2(\overline{f}) 
&= &\int_{[0,1]^s} \overline{f}(\bx)^2 d\bx - E(\overline{f})^2 \\
&= &\frac{1}{\sigma^2(f)} \int_{[0,1]^s} \left( f(\bx) - E(f)\right)^2 d\bx\\
&= &\frac{1}{\sigma^2(f)} \left( \int_{[0,1]^s} f(\bx)^2 d\bx  - 2 E(f) \int_{[0,1]^s} f(\bx) d\bx  + E(f)^2\right)\\
&= &\frac{1}{\sigma^2(f)} \left( \int_{[0,1]^s} f(\bx)^2 d\bx  - 2 E(f) E(f)  + E(f)^2\right)\\
&= &\frac{1}{\sigma^2(f)} \left( \int_{[0,1]^s} f(\bx)^2 d\bx  - E(f)^2\right)\\
&= &\frac{1}{\sigma^2(f)} \sigma^2(f)\\
& = & 1.
\end{eqnarray}

Hence the expectation of the function $\overline{f}$ is zero while its 
variance is one. 
In the bibliography, we often find functions with non-zero expectation or non-unity
variance. In these cases, when both the expectation and the variance are explicitely known, 
we use the formula \ref{intprb-normalizedf} and provide the function $\overline{f}$ instead of $f$.
If the expectation only is known, we cannot normalize the variance and we provide 
the function $f(\bx) - E(f)$ instead of $f$. When the expectation is not known 
analytically, we provide $f$ directly.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Functions}

In this section, we describe the functions provided in the 
toolbox. 
We provide the function definition and the references were the 
function appeared first. 
We also list several papers using the function and which may provide 
an analysis or numerical experiments using the function: this may be useful in 
comparison studies. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{SUM}

This is the function $F_1$ in Kocis and Whiten's \cite{KocisWhiten1997}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \frac{1}{\sqrt{v}} ( g(\bx) - e ),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
e &=& \frac{s}{2}\\
v &=& \frac{s}{12}\\
g(\bx) &=& \sum_{i=1,\ldots,s} x_i.
\end{eqnarray}

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testsum}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-sum.pdf}
\end{center}
\caption{The function SUM.}
\label{fig-intprb-testsum}
\end{figure}

The function $f$ is well behaved and thus satisfies conditions 
for proper quasi-Monte-Carlo integration. But it is not truly
multi-dimensional in that it is a sum of lower-dimensional functions.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{SQSUM}

This is the function $F_2$ in Kocis and Whiten's \cite{KocisWhiten1997}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \frac{1}{\sqrt{v}} ( g(\bx) - e ),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
e &=& \frac{s}{3}\\
v &=& \frac{4n}{45}\\
g(\bx) &=& \sum_{i=1,\ldots,s} x_i^2.
\end{eqnarray}

The function $f$ is well behaved and thus satisfies conditions 
for proper quasi-Monte-Carlo integration. But it is not truly
multi-dimensional in that it is a sum of lower-dimensional functions.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testsqsum}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-sqsum.pdf}
\end{center}
\caption{The function SQSUM.}
\label{fig-intprb-testsqsum}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{SUMSQROOT}

This is the function $F_3$ in Kocis and Whiten's \cite{KocisWhiten1997}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \frac{1}{\sqrt{v}} ( g(\bx) - e ),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
e &=& \frac{2n}{3}\\
v &=& \frac{s}{18}\\
g(\bx) &=& \sum_{i=1,\ldots,s} \sqrt{x_i}.
\end{eqnarray}

The function $f$ is well behaved and thus satisfies conditions 
for proper quasi-Monte-Carlo integration. But it is not truly
multi-dimensional in that it is a sum of lower-dimensional functions.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testsumsqroot}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-sumsqroot.pdf}
\end{center}
\caption{The function SUMSQROOT.}
\label{fig-intprb-testsumsqroot}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{PRODONES}

This is the function $F_4$ in Kocis and Whiten's \cite{KocisWhiten1997}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \prod_{i=1,\ldots,s} g(x_i),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
g(z) = 
\left\{
\begin{array}{ll}
-1 & \textrm{ if } z< \frac{1}{2}\\
1  & \textrm{ otherwise.}
\end{array}
\right.
\end{eqnarray}

The function $f$ is discontinuous, but the function is either 1 or -1
(i.e. the local extremes of the function do not increase with the dimension $s$). 
The function is piecewise constant in $2^s$ different regions.
The conditions for proper quasi-Monte Carlo are not satisfied and the rate 
of convergence for this function is expected to be low.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testprodones}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-prodones.pdf}
\end{center}
\caption{The function PRODONES.}
\label{fig-intprb-testprodones}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\subsection{PRODEXP}

This is the function $F_5$ in Kocis and Whiten's \cite{KocisWhiten1997}.

This function is defined by 
\begin{eqnarray}
f(\bx) = w^s \prod_{i=1,\ldots,s} g(x_i),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
w & = & \left( \frac{15\exp(15) + 15}{13\exp(15) + 17} \right)^{\frac{1}{2}} \\
g(z) & = & \frac{\exp(30z - 15) - 1}{\exp(30z - 15) + 1}
\end{eqnarray}

The function $f$ is smooth but the number of extremes increases as $2^s$.
For example, the maximum of the function $f$ in the 
hypercube $[0,1]^s$ is $2.69 \cdot 10^{12}$ for $s=400$.
The conditions for proper quasi-Monte Carlo are not satisfied and the rate 
of convergence for this function is expected to be low.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testprodexp}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-prodexp.pdf}
\end{center}
\caption{The function PRODEXP.}
\label{fig-intprb-testprodexp}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{PRODCUB}

This is the function $F_6$ in Kocis and Whiten's \cite{KocisWhiten1997}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \prod_{i=1,\ldots,s} g(x_i),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
g(z) & = & -2.4 \sqrt{7} \left(z-\frac{1}{2}\right) + 8 \sqrt{7} \left(z-\frac{1}{2}\right)^3.
\end{eqnarray}

The function $f$ is smooth but the number of extremes increases as $2^s$.
For example, the maximum of the function $f$ in the 
hypercube $[0,1]^s$ is $4.65 \cdot 10^{50}$ for $s=400$.
The conditions for proper quasi-Monte Carlo are not satisfied and the rate 
of convergence for this function is expected to be low.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testprodcub}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-prodcub.pdf}
\end{center}
\caption{The function PRODCUB.}
\label{fig-intprb-testprodcub}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{PRODX}

This is the function $F_7$ in Kocis and Whiten's \cite{KocisWhiten1997}.

This function is defined by 
\begin{eqnarray}
f(\bx) = w^s \prod_{i=1,\ldots,s} g(x_i),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
w    & = & 2\sqrt{3} \\
g(z) & = & z-\frac{1}{2}.
\end{eqnarray}

The function $f$ is smooth but the number of extremes increases as $2^s$.
For example, the maximum of the function $f$ in the 
hypercube $[0,1]^s$ is $2.66 \cdot 10^{95}$ for $s=400$.
The conditions for proper quasi-Monte Carlo are not satisfied and the rate 
of convergence for this function is expected to be low.

Owen analyses this function in \cite{OwenDimdist2003} and 
reports previous results from \cite{ScrambledNetOwen1997} and 
\cite{Owen97scramblingsobol}.
This test function is fully $s$ dimensional and the improvement 
of QMC over MC sets in at $n\geq b^s$, where $b$ is the base of the 
$(\lambda,0,m,s)-net$. 
In \cite{Owen97scramblingsobol}, Owen indicates that 
the function $f$ is multilinear, so that $f$ is not artificially
easy for scrambled nets, at least in terms of the rates of 
convergence to be expected. Owen writes "there are harder $s$ dimensional 
integrands, such as oscillatory or localized ones". 

Owen also explains the behavior of MC and QMC algorithms when $s$ becomes large.
"In large dimensions, this integrand is difficult for MC. Indeed, most of the variation
is concentrated in $2^s$ small corner regions. For large $s$ and 
small $n$, the MC estimate will be usually very close to the exact zero, 
because non of the corner spikes will have been sampled. But, as 
the number of simulations $n$ increases, a small number of 
spike samples will be obtained and the result will be erratic
until $n$ becomes so large that a large number of spike samples 
has been seen."

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testprodx}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-prodx.pdf}
\end{center}
\caption{The function PRODX.}
\label{fig-intprb-testprodx}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{SUMFIFJ}

This is the function $F_8$ in Kocis and Whiten's \cite{KocisWhiten1997}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \frac{1}{\sqrt{v}} \sum_{i=1,\ldots,s} g_i(\bx),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
g_i(\bx) & = & g(x_i) \sum_{j=1,2,\ldots,i-1} g(x_j).
\end{eqnarray}
The function $g$ is defined by 
\begin{eqnarray}
g(z) = 
\left\{
\begin{array}{ll}
1 & \textrm{ if } z< \frac{1}{6} \textrm{ or } z > \frac{4}{6}\\
0 & \textrm{ if } z= \frac{1}{6} \textrm{ or } z = \frac{4}{6}\\
-1 & \textrm{ if } z> \frac{1}{6} \textrm{ and } z > \frac{4}{6}.
\end{array}
\right.
\end{eqnarray}

The function $f$ has only two-dimensional components being 
constructed as sum of products of all combinations of two-one variate
functions. This allows the simultaneous testing and averaging of all the 
possible two-dimensional functions available within the chosen dimension $s$. 
The function $F_8$ corresponds to the function $F_5$, having flat regions 
and discontinuities.
The number of regions of $F_8$ is $3^s$. 
The extremes of the function $f$ do not increase rapidly with the number of 
dimensions $s$.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testsumfifj}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-sumfifj.pdf}
\end{center}
\caption{The function SUMFIFJ.}
\label{fig-intprb-testsumfifj}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{SUMF1FJ}

This is a modification of the function $F_9$ in Kocis and Whiten's \cite{KocisWhiten1997}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \frac{1}{\sqrt{s-1}} g(x_1) \sum_{i=2,\ldots,s} g(x_i),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
g(z) = 27.20917094 z^3 - 36.19250850 z^2 + 8.983337562 z + 0.7702079855.
\end{eqnarray}

The function $f$ has only two-dimensional components being 
constructed as sum of products of all combinations of two-one variate
functions. This allows the simultaneous testing and averaging of all the 
possible two-dimensional functions available within the chosen dimension $s$. 
The function $F_8$ corresponds to the function $F_6$, being smooth and 
based on one-dimensional cubic functions.
The extremes of the function $f$ do not increase rapidly with the number of 
dimensions $s$.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testsumf1fj}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-sumf1fj.pdf}
\end{center}
\caption{The function SUMF1FJ.}
\label{fig-intprb-testsumf1fj}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{HELLEKALEK}

This function is from \cite{Hellekalek1998} and is called "Hellekalek's example" in \cite{OwenDimdist2003}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \prod_{i=1,\ldots,s} g(x_i),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
g(z) & = & \frac{h(z)}{\gamma_i}  \\
h(z) & = & z^\alpha - \frac{1}{\alpha+1}.
\end{eqnarray}
The parameter $\alpha$ ranges from 1 to 3. In the toolbox, we have chosen 
\begin{eqnarray}
\alpha=1.
\end{eqnarray}
The variable $\gamma_i^2$ represents the variance of the function $h(x_i)$ for $i=1,2,\ldots,s$, 
which satisfies 
\begin{eqnarray}
\gamma_i^2 &= & \frac{\alpha^2}{(2\alpha + 1)(\alpha+1)^2}.
\end{eqnarray}

Owen \cite{OwenDimdist2003} prooves that this function is fully $s$-dimensionnal.
Hence QMC does not improve on Monte-Carlo. A $(t,m,s)$-net does not balance 
any elementary intervals of dimension $s$, unless $n \geq b^{t+s}$.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testhellekalek}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-hellekalek.pdf}
\end{center}
\caption{The function HELLEKALEK.}
\label{fig-intprb-testhellekalek}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{ROOSARNOLD1}

This function is from Roos and Arnold \cite{Roos1963} and is presented 
in Davis and Rabinowitz \cite{Davis1984}.
It is analysed by Owen \cite{OwenDimdist2003}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \frac{1}{\sqrt{v}} \left( \sum_{i=1,\ldots,s} g(x_i) - e \right),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
g(z) & = & \frac{|4z-2|}{s}, \\
e & = & 1, \\
v & = & \frac{1}{3s}.
\end{eqnarray}

Owen writes in \cite{OwenDimdist2003} that this 
function is additive and purely one dimensional.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testroosarnold1}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-roosarnold1.pdf}
\end{center}
\caption{The function ROOSARNOLD1.}
\label{fig-intprb-testroosarnold1}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{ROOSARNOLD2}

This function is from Roos and Arnold \cite{Roos1963} and is presented 
in Davis and Rabinowitz \cite{Davis1984}.
This integrand is considered in the context of QMC by Fox in \cite{Fox1986}.
This integrand can be viewed as a particular case of Radovic, Sobol and Tichy's function \cite{RaSoTi1996},
analysed by Owen \cite{OwenDimdist2003}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \frac{1}{\sqrt{v}} \left( \prod_{i=1,\ldots,s} g(x_i) - e \right),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
g(z) & = & |4z-2|, \\
e & = & 1, \\
v & = & \left(\frac{4}{3}\right)^s - 1.
\end{eqnarray}

All variables are important in this function.

In \cite{Fox1986}, Fox analyses this function. 
Consider $V(f)$, the variation of $f$ in the sense of Hardy and Krause.
It is possible to show that 
\begin{eqnarray}
V(f) \geq \sup \{ f(\bx) | \bx\in[0,1]^s\} - \inf \{ f(\bx) | \bx\in[0,1]^s\}.
\end{eqnarray}
For the current function, we have 
\begin{eqnarray}
V(f) \geq 2^s.
\end{eqnarray}
This shows that a huge error is possible in any approximation 
method when $s$ is large.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testroosarnold2}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-roosarnold2.pdf}
\end{center}
\caption{The function ROOSARNOLD2.}
\label{fig-intprb-testroosarnold2}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{ROOSARNOLD3}

This function is from Roos and Arnold \cite{Roos1963} and is presented 
in Davis and Rabinowitz \cite{Davis1984}.
It is analysed by Owen \cite{OwenDimdist2003}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \frac{1}{\sqrt{v}} \left( \prod_{i=1,\ldots,s} g(x_i) - e \right),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
g(z) & = & \frac{\pi}{2} \sin(\pi z), \\
e & = & 1, \\
v & = & \left(\frac{\pi^2}{8}\right)^s - 1.
\end{eqnarray}

Owen writes in \cite{OwenDimdist2003} that this 
function has mean dimensionnality which grows nearly linearly with $s$.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-testroosarnold3}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-roosarnold3.pdf}
\end{center}
\caption{The function ROOSARNOLD3.}
\label{fig-intprb-testroosarnold3}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{RST1, RST2, RST3}

This function is from Radovic, Sobol and Tichy \cite{RaSoTi1996}.
It is analysed by Owen in \cite{OwenDimdist2003}, by Okten, Shah and Goncharov in \cite{Okten2009}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \frac{1}{\sqrt{v}} \left( \prod_{i=1,\ldots,s} g_i(x_i) - e \right),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
g_i(z) & = & \frac{|4z-2|+a_i}{1+a_i}.
\end{eqnarray}

The parameters $a_i$ for $i=1,2,\ldots,s$ allows to tune the importance of 
each variable $x_i$. If $a_i=0$, then the parameter $x_i$ is important and 
when $a_i\geq 0$ is larger, the variable $x_i$ is less important.
We use the following set of parameters:
\begin{itemize}
\item RST1 uses $a_i=1$ for $i=1,2,\ldots,s$, where all variables have equal importance, 
\item RST2 uses $a_i=i$ for $i=1,2,\ldots,s$, where the importance of the variable $x_i$ decreases as $i$ increases, 
\item RST3 uses $a_i=i^2$ for $i=1,2,\ldots,s$, where the importance of the variable $x_i$ decreases as $i$ increases.
\end{itemize}
The expectation and variance of the function $f$ can be computed based on the expectation
and variance of the functions $g_i$. 
Let us define 
\begin{eqnarray}
\mu_i & =& 1, \\
\gamma_i^2 & =& \frac{1}{3(1+a_i)^2},
\end{eqnarray}
for $i=1,2,\ldots,s$. 
Then, the expectation and variances of the function $f$ are 
\begin{eqnarray}
e & =&  \prod_{i=1,\ldots,s} \mu_i \\
v & =&  \prod_{i=1,\ldots,s} (\mu_i^2 + \gamma_i^2) - \prod_{i=1,\ldots,s} \mu_i^2.
\end{eqnarray}

For numerical integration, the function RST1 may be difficult, RST2 more easy and RST3 easy.

The contours of this function in the case $s=2$ are 
presented in the figures \ref{fig-intprb-testrst1}, 
\ref{fig-intprb-testrst2} and \ref{fig-intprb-testrst3}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-rst1.pdf}
\end{center}
\caption{The function RST1.}
\label{fig-intprb-testrst1}
\end{figure}

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-rst2.pdf}
\end{center}
\caption{The function RST2.}
\label{fig-intprb-testrst2}
\end{figure}

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-rst3.pdf}
\end{center}
\caption{The function RST3.}
\label{fig-intprb-testrst3}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{SOBOLPROD}

This function is designed by Sobol' in \cite{Sobol1994}.
It is analysed by Owen in \cite{OwenDimdist2003}.

This function is defined by 
\begin{eqnarray}
f(\bx) = \frac{1}{\sqrt{v}} \left( \prod_{i=1,\ldots,s} g_i(x_i) - e \right),
\end{eqnarray}
where $\bx\in[0,1]^s$ and 
\begin{eqnarray}
g_i(z) & = & \frac{i+2z}{i+1}.
\end{eqnarray}
The expectation and variance of the function $f$ can be computed based on the expectation
and variance of the functions $g_i$. 
Let us define 
\begin{eqnarray}
\mu_i & =& 1, \\
\gamma_i^2 & =& \frac{1}{3(i+1)^2},
\end{eqnarray}
for $i=1,2,\ldots,s$. 
Then, the expectation and variances of the function $f$ are 
\begin{eqnarray}
e & =&  \prod_{i=1,\ldots,s} \mu_i \\
v & =&  \prod_{i=1,\ldots,s} (\mu_i^2 + \gamma_i^2) - \prod_{i=1,\ldots,s} \mu_i^2.
\end{eqnarray}

This function is an integrand which is favorable for quasi Monte Carlo.
Sobol's shows in \cite{Sobol1994} a convergence of the error which has 
the form $1/n$ instead of the $1/\sqrt{n}$ of the Monte Carlo method.

Owen states in \cite{OwenDimdist2003} that each variable $x_{i+1}$ is 
less important than $x_i$.
This integrand really depends on few variables. 
Owen writes that, for $s=100$, the mean dimension is 1.085.
He writes that, for $s=100$, at least 99.418\% of the variation
in this function is from its ANOVA components of dimension 4 and smaller.


The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-sobolprod}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-sobolprod.pdf}
\end{center}
\caption{The function SOBOLPROD.}
\label{fig-intprb-sobolprod}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{OSCILL}
\label{intprb-oscill}

The next 6 functions are a part of the 6 functions designed by Genz and available in the 
Testpack fortran 77 package \cite{GenzTestpack}. 
These functions have been ported to Matlab by John Burkardt in \cite{BurkardtTestpack}
and in \cite{BurkardtQuadtest}.

The OSCILL function is designed by Genz in \cite{Genz1984}, \cite{Genz1987},
where it is named "Oscillatory".
It is used by Joe and Sloan in \cite{Joe:1993:ILM,Joe:1994:CIL} (1993), 
by Sh\"urer in \cite{Shurer2001} (2001), 
by Taylor and Hover in \cite{TaylorHover2007} (2007), 
by Pirsic in \cite{PirsicWWWGenz,Pirsic01asoftware}.

This function is defined by :
\begin{eqnarray}
f(\bx) = \cos \left( 2\pi \beta_1 + \sum_{i=1,2,\ldots,s} \alpha_i x_i\right) - e,
\end{eqnarray}
where $\bx\in[0,1]^s$ and $e$ is defined by :
\begin{eqnarray}
e & = & 2^s \cos \left( 2 \pi \beta_1 + \frac{1}{2} \hat{\alpha} \right) p \\
\hat{\alpha} & = & \sum_{i=1}^s\alpha_i \\
p & = & \prod_{i=1}^s \frac{ \sin (\alpha_i / 2) }{\alpha_i}      
\end{eqnarray}
For this function, the expectation is known, but not the variance.
This function is not completely normalized, in the sense that its integral is zero
buts its variance is not unity.

In this function, the parameters $\alpha = (\alpha_1,\alpha_2,\ldots,\alpha_s)$ and 
$\beta=(\beta_1,\beta_2,\ldots,\beta_s)$ allow to define a family of functions.

In \cite{Genz1984}, Genz distinguish two types of parameters 
which appear in an integration function.
\begin{enumerate}
\item Affective parameters are the parameters which affect the difficulty
of the integration problem. This is the parameter $\alpha$ (denoted by $\ba$ in \cite{Genz1984}).
\item Unaffective parameters are the one which do not affect the 
difficulty of the integration problem. This is the parameter $\beta$  (denoted by $\bu$ in \cite{Genz1984}).
\end{enumerate}

The components of $\hat{\alpha}$ and $\beta$ are uniformly distributed in the interval $[0,1]$.
The vector $\beta$ acts as a shift parameter. 
As detailed below, the vector $\alpha$ is then computed by scaling $\hat{\alpha}$.

Genz uses the uniform random number generator designed by Shrage in \cite{Shrage1979}. 
The generator is based on the multiplicative congruential generator 
\begin{eqnarray}
x = A x (\pmod M) 
\end{eqnarray}
with $A = 16807$ and $M = 2^{31} - 1 = 2147483647$. 
Schrage states that the generator is full cycle, with period $M$.
In our implementation, the seed is constantly set to 123456.

The difficulty of the problem is controlled by the vector $\alpha$, where 
increasing values of $\alpha$ are generating increasingly difficult problems.
The scaling of $\alpha$ is done by the formula 
\begin{eqnarray}
\label{intprb-oscill-1}
\alpha = \frac{1}{\omega} \hat{\alpha}
\end{eqnarray}
where $\omega > 0$ is defined by :
\begin{eqnarray}
\label{intprb-oscill-2}
\omega = \frac{s^e}{h} \sum_{i=1}^s \alpha_i.
\end{eqnarray}
The parameters $e$ and $h$ are chosen depending on the problem 
in order to control the difficulty of the integration.
The previous equation leads to the equality $\|\alpha\|_1=\frac{h}{s^e}$.

For this function, we have $e=1.5$ and $h=110$, which leads to 
\begin{eqnarray}
\|\alpha\|_1 = \frac{110}{s^{3/2}}.
\end{eqnarray}

A little modification was done to the function with respect to the 
Testpack library \cite{GenzTestpack}.
In Genz's testpack, the integration is done over an interval $[\ba,\bb]$, 
with $\ba=(0,0,\ldots,0)^T$ and $\bb = (\alpha,\alpha,\ldots,\alpha)^T$.
Here, the integration is done over the unit interval $[0,1]^s$, 
so that multiplying $x$ by $\alpha$ is necessary to get the same problem.

According to Schurer, this integrand is very smooth, 
such that adaptive algorithms based on cubature performs 
better than Quasi-Monte-Carlo, even for a dimension as high 
as $s=40$. 
On \cite{PirsicWWWGenz}, Pirsic used the Oscillatory function 
in dimensions $s=4$ to $s=16$ with a number of experiments 
$n=2^{21}\approx 10^6$. The results show a good 
improvement of QMC over crude Monte-Carlo, especially for 
low dimension, e.g. for $s\leq 10$. 

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-oscill}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-oscill.pdf}
\end{center}
\caption{The function OSCILL.}
\label{fig-intprb-oscill}
\end{figure}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{PRPEAK}
\label{intprb-prpeak}

This function is part of the 6 functions designed by Genz and available in the 
Testpack fortran 77 package \cite{GenzTestpack}. 
This function has been ported to Matlab by John Burkardt in \cite{BurkardtTestpack}
and in \cite{BurkardtQuadtest}.

The PRPEAK function is designed by Genz in \cite{Genz1984}, \cite{Genz1987},
where it is named "Product Peak".
It is used by Joe and Sloan in \cite{Joe:1993:ILM,Joe:1994:CIL} (1993), 
by Sh\"urer in \cite{Shurer2001} (2001), 
by Owen in \cite{OwenDimdist2003} (2003).

This function is defined by 
\begin{eqnarray}
f(\bx) = \prod_{i=1}^s \left( \alpha_i^{-2} + (x_i-\beta_i)^2 \right)^{-1} - e,
\end{eqnarray}
where $\bx\in[0,1]^s$ and $e$ is defined by :
\begin{eqnarray}
e   & = & \prod_{i=1}^s \left( (s_i - t_i) \alpha_i \right),\\
s_i & = & \arctan ((1-\beta_i)\alpha_i),\\
t_i & = & \arctan(-\beta_i \alpha_i).
\end{eqnarray}
For this function, the expectation is known, but not the variance.
This function is not completely normalized, in the sense that its integral is zero
buts its variance is not unity.

The vector $\alpha$ is scaled by the equations \ref{intprb-oscill-1}-\ref{intprb-oscill-2}
with $e=2$ and $h=600$.

In \cite{PirsicWWWGenz}, Pirsic used the Oscillatory function 
in dimensions $s=4$ to $s=16$ with a number of experiments 
$n=2^{21}\approx 10^6$. The results show a good 
improvement of QMC over crude Monte-Carlo, whatever the dimension. 

In \cite{OwenDimdist2003}, Owen states that the hard cases for this 
function are only of approximate dimension $s/2$.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-prpeak}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-prpeak.pdf}
\end{center}
\caption{The function PRPEAK.}
\label{fig-intprb-prpeak}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{CORPEAK}
\label{intprb-corpeak}

The CORPEAK function is designed by Genz in \cite{Genz1984}, \cite{Genz1987},
where it is named "Corner Peak".

It is used by Sh\"urer in \cite{Shurer2001} (2001),
by Joe and Sloan in \cite{Joe:1993:ILM,Joe:1994:CIL} (1993).

This function is defined by 
\begin{eqnarray}
f(\bx) = \left( 1 + \sum_{i=1}^s t_i\right)^{-n-1} - e,
\end{eqnarray}
where $\bx\in[0,1]^s$ and $t_i$ is defined by :
\begin{eqnarray}
t_i = 
\left\{
\begin{array}{ll}
\alpha_i x_i,            & \textrm{ if } \beta_i < 0.5 \\
\alpha_i - \alpha_i x_i, & \textrm{ if not.}
\end{array}
\right.
\end{eqnarray}
The computation of $e$ is done based on an algorithm which is 
not straightforward (see the source code for details).
For this function, the expectation is known, but not the variance.
This function is not completely normalized, in the sense that its integral is zero
buts its variance is not unity.

The vector $\alpha$ is scaled by the equations \ref{intprb-oscill-1}-\ref{intprb-oscill-2}
with $e=2$ and $h=600$.

A little modification was done to the function with respect to the 
Testpack library \cite{GenzTestpack}.
In Genz's testpack, the integration is done over an interval $[\ba,\bb]$, 
with $\ba=(0,0,\ldots,0)^T$ and $\bb = (\alpha,\alpha,\ldots,\alpha)^T$.
Here, the integration is done over the unit interval $[0,1]^s$, 
so that multiplying $x$ by $\alpha$ is necessary to get the same problem.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-corpeak}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-corpeak.pdf}
\end{center}
\caption{The function CORPEAK.}
\label{fig-intprb-corpeak}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{GAUSSIAN}
\label{intprb-gaussian}

The GAUSSIAN function is designed by Genz in \cite{Genz1984}, \cite{Genz1987},
where it is named "Gaussian".
It is used by Owen in \cite{OwenDimdist2003} (2003), 
by Sh\"urer in \cite{Shurer2001} (2001),
by Joe and Sloan in \cite{Joe:1993:ILM,Joe:1994:CIL} (1993).

This function is defined by 
\begin{eqnarray}
f(\bx) = \exp \left( -\sum_{i=1}^s \alpha_i^2 (x_i-\beta_i)^2 \right) - e,
\end{eqnarray}
where $\bx\in[0,1]^s$ and $e$ is defined by :
\begin{eqnarray}
e   & = & \prod_{i=1}^s \frac{\sqrt{\pi}}{\alpha_i} \left( r_i -  t_i \right), \\
r_i & = & \phi \left(( 1 - \beta_i ) \sqrt{2} \alpha_i \right), \\
t_i & = & \phi \left( - \beta_i \sqrt{2} \alpha_i \right),
\end{eqnarray}
where $\phi$ is the standard normal (Laplace-Gauss) cumulated distribution function, 
defined by 
\begin{eqnarray}
\phi(x) = \frac{1}{\sqrt{2\pi}} \int_{-\infty}^x \exp \left(-\frac{s^2}{2} \right) ds.
\end{eqnarray}
For this function, the expectation is known, but not the variance.
This function is not completely normalized, in the sense that its integral is zero
buts its variance is not unity.

The vector $\alpha$ is scaled by the equations \ref{intprb-oscill-1}-\ref{intprb-oscill-2}
with $e=1$ and $h=100$.

Genz provides in Testpack \cite{GenzTestpack} its own implementation of the 
function $\phi$. In Scilab, we use the \scifun{cdfnor} function.

In \cite{OwenDimdist2003}, Owen states that if 
the parameters $\alpha_i$ are large enough, this function is essentially
full dimension $s$.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-gaussian}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-gaussian.pdf}
\end{center}
\caption{The function GAUSSIAN.}
\label{fig-intprb-gaussian}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{C0}
\label{intprb-C0}

The C0 function is designed by Genz in \cite{Genz1984}, \cite{Genz1987},
where it is named "C0 Function" (other authors uses the term "Continuous").

It is used by Petras in \cite{Petras2003} (2003), 
by Owen in \cite{OwenDimdist2003} (2003),
by Sh\"urer in \cite{Shurer2001} (2001),
by Joe and Sloan in \cite{Joe:1993:ILM,Joe:1994:CIL} (1993).

This function is defined by 
\begin{eqnarray}
f(\bx) = \exp \left( -\sum_{i=1}^s \alpha_i | x_i - \alpha_i | \right) - e,
\end{eqnarray}
where $\bx\in[0,1]^s$ and $e$ is defined by :
\begin{eqnarray}
e   & = & \prod_{i=1}^s t_i, \\
t_i & = & \left( 2 -  \exp ( - \alpha_i\beta_i ) - \exp ( \alpha_i\beta_i - \alpha_i ) \right) / \alpha_i.
\end{eqnarray}
For this function, the expectation is known, but not the variance.
This function is not completely normalized, in the sense that its integral is zero
buts its variance is not unity.

The vector $\alpha$ is scaled by the equations \ref{intprb-oscill-1}-\ref{intprb-oscill-2}
with $e=2$ and $h=150$.

In \cite{OwenDimdist2003}, Owen states that if 
the parameters $\alpha_i$ are large enough, this function is essentially
full dimension $s$.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-c0}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-c0.pdf}
\end{center}
\caption{The function C0.}
\label{fig-intprb-c0}
\end{figure}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{DISCONT}
\label{intprb-discont}

The DISCONT function is designed by Genz in \cite{Genz1984}, \cite{Genz1987},
where it is named "Discontinuous".
It is used by Petras in \cite{Petras2003} (2003), 
by Owen in \cite{OwenDimdist2003} (2003), 
by Sh\"urer in \cite{Shurer2001} (2001),
by Joe and Sloan in \cite{Joe:1993:ILM,Joe:1994:CIL} (1993).

This function is defined by 
\begin{eqnarray}
f(\bx) = 
\left\{
\begin{array}{l}
-e, \textrm{ if } x_1 > \beta_1, \textrm{ and } x_2 > \beta_2, \ldots, \textrm{ and } x_s > \beta_s,\\
\exp \left( \sum_{i=1}^s \alpha_i x_i\right) - e, \textrm{ if not.}
\end{array}
\right.,
\end{eqnarray}
where $\bx\in[0,1]^s$ and $e$ is defined by :
\begin{eqnarray}
e   & = & \prod_{i=1}^s \frac{\exp ( \alpha_i \beta_i ) - 1}{ \alpha_i}.
\end{eqnarray}
For this function, the expectation is known, but not the variance.
This function is not completely normalized, in the sense that its integral is zero
buts its variance is not unity.

The vector $\alpha$ is scaled by the equations \ref{intprb-oscill-1}-\ref{intprb-oscill-2}
with $e=2$ and $h=100$.

Notice that the simpler condition "$x_1>\beta_1\textrm{ or } x_2>\beta_2$" is 
used in \cite{Genz1984}.

In \cite{OwenDimdist2003}, considering the same function with the 
condition "$x_1>\beta_1\textrm{ or } x_2>\beta_2$", Owen states that if 
the parameters $\alpha_i$ are large enough, this function is essentially
full dimension $s$.

The contours of this function in the case $s=2$ are 
presented in the figure \ref{fig-intprb-discont}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{test-discont.pdf}
\end{center}
\caption{The function DISCONT.}
\label{fig-intprb-discont}
\end{figure}

